SELECT
	UTB.TABLE_NAME,
	UTB.COLUMN_NAME,
	UCC.COMMENTS ATTRIBUTE_NAME,
	UTB.COLUMN_ID,
	DECODE(NVL(SPK.CNT,0),0,'NO','YES') PK,
	DECODE(NVL(SFK.CNT,0),0,'NO','YES') FK,
	DECODE(UTB.NULLABLE,'N','YES','NO') NN,
	UTB.DATA_TYPE,
	UTB.DATA_LENGTH,
	UTB.DATA_PRECISION
FROM
	USER_TAB_COLUMNS UTB
		INNER JOIN USER_COL_COMMENTS UCC ON
		      UTB.TABLE_NAME = UCC.TABLE_NAME
		  AND UTB.COLUMN_NAME = UCC.COLUMN_NAME
		LEFT OUTER JOIN (
			SELECT
				UCN.TABLE_NAME,
				UCL.COLUMN_NAME,
				COUNT(*) CNT
			FROM
				USER_CONSTRAINTS UCN,
				USER_CONS_COLUMNS UCL
			WHERE
				    UCN.CONSTRAINT_TYPE = 'P'
				AND UCN.CONSTRAINT_NAME = UCL.CONSTRAINT_NAME
			GROUP BY
				UCN.TABLE_NAME,
				UCL.COLUMN_NAME
		) SPK ON UTB.TABLE_NAME = SPK.TABLE_NAME AND UCC.COLUMN_NAME = SPK.COLUMN_NAME
		LEFT OUTER JOIN (
			SELECT
				UCN.TABLE_NAME,
				UCL.COLUMN_NAME,
				COUNT(*) CNT
			FROM
				USER_CONSTRAINTS UCN,
				USER_CONS_COLUMNS UCL
			WHERE
				    UCN.CONSTRAINT_TYPE = 'R'
				AND UCN.CONSTRAINT_NAME = UCL.CONSTRAINT_NAME
			GROUP BY
				UCN.TABLE_NAME,
				UCL.COLUMN_NAME
		) SFK ON UTB.TABLE_NAME = SFK.TABLE_NAME AND UCC.COLUMN_NAME = SFK.COLUMN_NAME
ORDER BY
	UTB.TABLE_NAME,
	UTB.COLUMN_ID
